#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bulcommn.h"

// Data types

const int MAX_ITEMS=128;

int read_palette_megadrv(unsigned char *palette, FILE *palfp, unsigned int nColors)
{
    int palSize=2*nColors;
    int readed=0;
    int colr_idx;
    for (colr_idx=0;colr_idx<nColors;colr_idx++)
    {
      if (feof(palfp)) break;
      unsigned char megapal[4];
      readed+=fread (&megapal, 1, 2, palfp);
      palette[colr_idx*3+2]=((megapal[0]>>1)&0x07)<<3;
      palette[colr_idx*3+1]=((megapal[1]>>5)&0x07)<<3;
      palette[colr_idx*3+0]=((megapal[1]>>1)&0x07)<<3;
    }
    if (palSize!=readed)
    {
      int ok_entries=readed>>1;
      if (nColors>ok_entries)
        memset(palette+ok_entries,0,nColors-ok_entries);
      return 2;
    }
    return 0;
}

int main(int argc, char *argv[])
{

    printf("\nSega Megadrive palettes decoder");
    printf("\n-------------------------------\n");
    if (argc<2)
    {
        printf("Not enought parameters.\n");
        printf("Usage:\n");
        printf("  synvgpal <filename>\n");
        printf("Input: file name with extension\n");
        printf("Output: many files\n");
    	return 1;
    }
    {
        char mpfname[255];
        sprintf(mpfname, "%s", argv[1]);
        FILE *mpalfp;
        mpalfp = fopen (mpfname, "rb");
        if (!mpalfp)
        {
            printf("Can't open input file file %s.\n", mpfname);
        	return 1;
        }
        fseek(mpalfp,0,SEEK_SET);
        int cntr=0;
        while (cntr<MAX_ITEMS)
        {
            if (feof(mpalfp))
            {
               printf("End of input file reached.\n");
               break;
            }
            char outfname[255];
            sprintf(outfname, "megpal%02d.pal",cntr);
            unsigned char palette[3*16+1];
            int err_no=0;
            err_no=read_palette_megadrv(palette,mpalfp,16);
            if (err_no!=0)
            {
               printf("Cannot read enought bytes for whole palette.\n");
            }
            printf("Writing palette file %s...", outfname);
            err_no=write_palette_rgb(palette,outfname,16);
            if (err_no==0) printf("ok\n"); else printf("error!\n");
            cntr++;
        }
        fclose(mpalfp);
    }

//  system("PAUSE");	
  return 0;
}
